movement and changes

This commit is contained in:
Luke Smith 2019-05-18 15:47:39 -04:00
parent 7b16c19f39
commit 3d6ceb918b
No known key found for this signature in database
GPG Key ID: 4C50B54A911F6252
5 changed files with 237 additions and 1 deletions

View File

@ -15,7 +15,7 @@ esac done
# DEFAULTS:
[ -z "$dotfilesrepo" ] && dotfilesrepo="https://github.com/lukesmithxyz/voidrice.git"
[ -z "$progsfile" ] && progsfile="https://raw.githubusercontent.com/LukeSmithxyz/LARBS/master/progs.csv"
[ -z "$progsfile" ] && progsfile="https://raw.githubusercontent.com/LukeSmithxyz/LARBS/master/archi3/progs.csv"
[ -z "$aurhelper" ] && aurhelper="yay"
### FUNCTIONS ###

BIN
archi3/larbs_readme.pdf Normal file

Binary file not shown.

View File

@ -3,6 +3,7 @@
,xorg-server,"is the graphical server."
,xorg-xwininfo,"allows querying information about windows."
,xorg-xinit,"starts the graphical server."
,sxhkd,"binds key."
,ttf-inconsolata,"is the monospace font of LARBS."
,ttf-linux-libertine,"provides the sans and serif fonts for LARBS."
,vifm,"is an extensive terminal file manager that everyone likes."
1 #TAG NAME IN REPO (or git url) PURPOSE (should be a verb phrase to sound right while installing)
3 xorg-server is the graphical server.
4 xorg-xwininfo allows querying information about windows.
5 xorg-xinit starts the graphical server.
6 sxhkd binds key.
7 ttf-inconsolata is the monospace font of LARBS.
8 ttf-linux-libertine provides the sans and serif fonts for LARBS.
9 vifm is an extensive terminal file manager that everyone likes.

168
voiddwm/vlarbs.sh Normal file
View File

@ -0,0 +1,168 @@
#!/bin/sh
# Luke's Auto Rice Boostrapping Script (LARBS)
# by Luke Smith <luke@lukesmith.xyz>
# License: GNU GPLv3
### OPTIONS AND VARIABLES ###
while getopts ":r:p:h" o; do case "${o}" in
h) printf "Optional arguments for custom use:\\n -r: Dotfiles repository (local file or url)\\n -p: Dependencies and programs csv (local file or url)\\n -h: Show this message\\n" && exit ;;
r) dotfilesrepo=${OPTARG} && git ls-remote "$dotfilesrepo" || exit ;;
p) progsfile=${OPTARG} ;;
*) printf "Invalid option: -%s\\n" "$OPTARG" && exit ;;
esac done
# DEFAULTS:
[ -z "$dotfilesrepo" ] && dotfilesrepo="https://github.com/lukesmithxyz/voidrice.git"
[ -z "$progsfile" ] && progsfile="https://raw.githubusercontent.com/LukeSmithxyz/LARBS/master/progs.csv"
### FUNCTIONS ###
error() { clear; printf "ERROR:\\n%s\\n" "$1"; exit;}
welcomemsg() { \
dialog --title "Welcome!" --msgbox "Welcome to Luke's Auto-Rice Bootstrapping Script!\\n\\nThis script will automatically install a fully-featured i3wm Void Linux desktop, which I use as my main machine.\\n\\n-Luke" 10 60
}
getuserandpass() { \
# Prompts user for new username an password.
name=$(dialog --inputbox "First, please enter a name for the user account." 10 60 3>&1 1>&2 2>&3 3>&1) || exit
while ! echo "$name" | grep "^[a-z_][a-z0-9_-]*$" >/dev/null 2>&1; do
name=$(dialog --no-cancel --inputbox "Username not valid. Give a username beginning with a letter, with only lowercase letters, - or _." 10 60 3>&1 1>&2 2>&3 3>&1)
done
pass1=$(dialog --no-cancel --passwordbox "Enter a password for that user." 10 60 3>&1 1>&2 2>&3 3>&1)
pass2=$(dialog --no-cancel --passwordbox "Retype password." 10 60 3>&1 1>&2 2>&3 3>&1)
while ! [ "$pass1" = "$pass2" ]; do
unset pass2
pass1=$(dialog --no-cancel --passwordbox "Passwords do not match.\\n\\nEnter password again." 10 60 3>&1 1>&2 2>&3 3>&1)
pass2=$(dialog --no-cancel --passwordbox "Retype password." 10 60 3>&1 1>&2 2>&3 3>&1)
done ;}
usercheck() { \
! (id -u "$name" >/dev/null) 2>&1 ||
dialog --colors --title "WARNING!" --yes-label "CONTINUE" --no-label "No wait..." --yesno "The user \`$name\` already exists on this system. LARBS can install for a user already existing, but it will \\Zboverwrite\\Zn any conflicting settings/dotfiles on the user account.\\n\\nLARBS will \\Zbnot\\Zn overwrite your user files, documents, videos, etc., so don't worry about that, but only click <CONTINUE> if you don't mind your settings being overwritten.\\n\\nNote also that LARBS will change $name's password to the one you just gave." 14 70
}
preinstallmsg() { \
dialog --title "Let's get this party started!" --yes-label "Let's go!" --no-label "No, nevermind!" --yesno "The rest of the installation will now be totally automated, so you can sit back and relax.\\n\\nIt will take some time, but when done, you can relax even more with your complete system.\\n\\nNow just press <Let's go!> and the system will begin installation!" 13 60 || { clear; exit; }
}
adduserandpass() { \
# Adds user `$name` with password $pass1.
dialog --infobox "Adding user \"$name\"..." 4 50
useradd -m -G wheel,users,audio,video,cdrom,input -s /bin/bash "$name" >/dev/null 2>&1 ||
usermod -a -G wheel,users,audio,video,chrom,input "$name" && mkdir -p /home/"$name" && chown "$name":wheel /home/"$name"
echo "$name:$pass1" | chpasswd
unset pass1 pass2 ;}
maininstall() { # Installs all needed programs from main repo.
dialog --title "LARBS Installation" --infobox "Installing \`$1\` ($n of $total). $1 $2" 5 70
xbps-install -y "$1" >/dev/null 2>&1
}
gitmakeinstall() {
repo="$(basename "$1")"
repodir="/home/$name/repos/$repo"
dialog --title "LARBS Installation" --infobox "Installing \`$(basename "$1")\` ($n of $total) via \`git\` and \`make\`. $(basename "$1") $2" 5 70
sudo -u "$name" mkdir -p "$repodir"
sudo -u "$name" git clone --depth 1 "$1" "/home/$name/repos/$repo" >/dev/null 2>&1
cd "$repodir" || exit
make install >/dev/null 2>&1
cd /tmp || return ;}
pipinstall() { \
dialog --title "LARBS Installation" --infobox "Installing the Python package \`$1\` ($n of $total). $1 $2" 5 70
command -v pip || pacman -S --noconfirm --needed python-pip >/dev/null 2>&1
yes | pip install "$1"
}
installationloop() { \
([ -f "$progsfile" ] && cp "$progsfile" /tmp/progs.csv) || curl -Ls "$progsfile" | sed '/^#/d' > /tmp/progs.csv
total=$(wc -l < /tmp/progs.csv)
while IFS=, read -r tag program comment; do
n=$((n+1))
echo "$comment" | grep "^\".*\"$" >/dev/null 2>&1 && comment="$(echo "$comment" | sed "s/\(^\"\|\"$\)//g")"
case "$tag" in
"") maininstall "$program" "$comment" ;;
"G") gitmakeinstall "$program" "$comment" ;;
"P") pipinstall "$program" "$comment" ;;
esac
done < /tmp/progs.csv ;}
putgitrepo() { # Downlods a gitrepo $1 and places the files in $2 only overwriting conflicts
dialog --infobox "Downloading and installing config files..." 4 60
dir=$(mktemp -d)
[ ! -d "$2" ] && mkdir -p "$2" && chown -R "$name:wheel" "$2"
chown -R "$name:wheel" "$dir"
sudo -u "$name" git clone --depth 1 "$1" "$dir/gitrepo" >/dev/null 2>&1 &&
sudo -u "$name" cp -rfT "$dir/gitrepo" "$2"
}
serviceinit() { for service in "$@"; do
dialog --infobox "Enabling \"$service\"..." 4 40
ln -s "/etc/sv/$service" /var/service/
sv start "$service"
done ;}
systembeepoff() { dialog --infobox "Getting rid of that retarded error beep sound..." 10 50
rmmod pcspkr
echo "blacklist pcspkr" > /etc/modprobe.d/nobeep.conf ;}
finalize(){ \
dialog --infobox "Preparing welcome message..." 4 50
echo "exec_always --no-startup-id notify-send -i ~/.scripts/larbs.png 'Welcome to LARBS:' 'Press Super+F1 for the manual.' -t 10000" >> "/home/$name/.config/i3/config"
dialog --title "All done!" --msgbox "Congrats! Provided there were no hidden errors, the script completed successfully and all the programs and configuration files should be in place.\\n\\nTo run the new graphical environment, log out and log back in as your new user, then run the command \"startx\" to start the graphical environment (it will start automatically in tty1).\\n\\n.t Luke" 12 80
}
### THE ACTUAL SCRIPT ###
### This is how everything happens in an intuitive format and order.
# Check if user is root on Arch distro. Install dialog.
xbps-install -Syu dialog || error "Are you sure you're running this as the root user? Are you sure you're using Void Linux? Are you sure you have an internet connection?"
# Welcome user.
welcomemsg || error "User exited."
# Get and verify username and password.
getuserandpass || error "User exited."
# Give warning if user already exists.
usercheck || error "User exited."
# Last chance for user to back out before install.
preinstallmsg || error "User exited."
### The rest of the script requires no user input.
adduserandpass || error "Error adding username and/or password."
dialog --title "LARBS Installation" --infobox "Installing \`basedevel\` and \`git\` for installing other software." 5 70
xbps-install -y curl base-devel git >/dev/null 2>&1
# The command that does all the installing. Reads the progs.csv file and
# installs each needed program the way required. Be sure to run this only after
# the user has been created and has priviledges to run sudo without a password
# and all build dependencies are installed.
installationloop
# Install the dotfiles in the user's home directory
putgitrepo "$dotfilesrepo" "/home/$name"
rm -f "/home/$name/README.md" "/home/$name/LICENSE"
# Install vim `plugged` plugins.
sudo -u "$name" mkdir -p "/home/$name/.config/nvim/autoload"
curl "https://raw.githubusercontent.com/junegunn/vim-plug/master/plug.vim" > "/home/$name/.config/nvim/autoload/plug.vim"
dialog --infobox "Installing (neo)vim plugins..." 4 50
(sleep 30 && killall nvim) &
sudo -u "$name" nvim -E -c "PlugUpdate|visual|q|q" >/dev/null 2>&1
# Enable services here.
serviceinit alsa NetworkManager wpa_supplicant
# Most important command! Get rid of the beep!
systembeepoff
# Last message! Install complete!
finalize
clear

67
voiddwm/vprogs.csv Normal file
View File

@ -0,0 +1,67 @@
#TAG,NAME IN REPO (or git url),PURPOSE (should be a verb phrase to sound right while installing)
,i3-gaps,"is the main graphical user interface and window manager."
,xorg-minimal,"is the graphical server."
,xorg-fonts,"is what is sounds like."
,libX11-devel,"is required for the compilation of some programs."
,libXft-devel,"is required for the compilation of some programs."
,webkit2gtk,"is the backend for the browser."
,webkit2gtk-devel,"is required for the compilation of some programs."
,fontconfig-devel,"is required for the compilation of some programs."
,xwininfo,"allows querying information about windows."
,xinit,"starts the graphical server."
,font-inconsolata-otf,"is the monospace font of LARBS."
,font-libertine-otf,"provides the sans and serif fonts for LARBS."
,lf,"is an extensive terminal file manager that everyone likes."
,arandr,"is a UI for screen adjustment."
,bc,"is used for a dropdown calculator."
,calcurse,"is a lightweight terminal-based calendar."
,xcompmgr,"is for transparency and removing screen-tearing."
,xorg-xprop,"is a tool for detecting window properties."
,libnotify,"allows desktop notifications."
,dunst,"is a suckless notification system."
,exfat-utils,"allows management of FAT drives."
,sxiv,"is a minimalist image viewer."
,xwallpaper,"sets the wallpaper."
,ffmpeg,"can record and splice video and audio on the command line."
,neovim,"an tidier vim with some useful features"
,i3blocks,"is the status bar."
,i3lock,"is the screen lock."
,mpd,"is a lightweight music daemon."
,mpc,"is a terminal interface for mpd."
,mpv,"is the patrician's choice video player."
,ncmpcpp,"a ncurses interface for music with multiple formats and a powerful tag editor."
,newsboat,"is a terminal RSS client."
,noto-fonts-emoji,"is a package that gives the system unicode symbols and emojis used in the status bar and elsewhere."
,font-symbola,"provides unicode and emoji symbols."
,alsa-utils,"is a package of audio utilities."
,imagemagick,"is a terminal image-manipulator providing some convenient shortcuts and the lockscreen in LARBS."
,sc-im,"is an Excel-like terminal spreadsheet manager."
,htop,"provides system usage information and displays processes."
,maim,"can take quick screenshots at your request."
,socat,"is a socket utility."
,tmux,"is a terminal multiplexer and the dropdown window in LARBS."
,unclutter-xfixes,"hides an inactive mouse."
,unrar,"extracts rar's."
,unzip,"unzips zips."
,w3m,"is a terminal browser which can also view images."
,xcape,"gives the special escape/super mappings of LARBS."
,xclip,"allows for copying and pasting from the command line."
,xdotool,"provides window action utilities on the command line."
,xdpyinfo,"aids with resolution determination and screen recording."
,youtube-dl,"can download any YouTube video (or playlist or channel) when given the link."
,zathura,"is a pdf viewer with vim-like bindings."
,zathura-djvu,"gives zathura the ability to read .djvu files."
,zathura-pdf-mupdf,"allows mupdf pdf compatibility in zathura."
,poppler,"manipulates .pdfs and gives .pdf previews and other .pdf functions."
,mediainfo,"shows audio and video information and is used by vifm as well."
,atool,"manages and gives information about archives."
,fzf,"is a fuzzy finder tool."
,highlight,"can highlight code output."
,xorg-xbacklight,"enables changing screen brightness levels."
,simple-mtpfs,"enables the mounting of cell phones."
G,https://github.com/lukesmithxyz/dmenu.git,"runs commands and provides a UI for selection."
G,https://github.com/lukesmithxyz/st.git,"is my custom build of suckless's terminal emulator."
G,https://github.com/lukesmithxtz/surf.git,"is the suckless web browser."
,docx2txt,"enables .docx file previews in vifm."
,odt2txt,"enables .odt file previews in vifm."
,ts,"queues commands or files for download."
1 #TAG NAME IN REPO (or git url) PURPOSE (should be a verb phrase to sound right while installing)
2 i3-gaps is the main graphical user interface and window manager.
3 xorg-minimal is the graphical server.
4 xorg-fonts is what is sounds like.
5 libX11-devel is required for the compilation of some programs.
6 libXft-devel is required for the compilation of some programs.
7 webkit2gtk is the backend for the browser.
8 webkit2gtk-devel is required for the compilation of some programs.
9 fontconfig-devel is required for the compilation of some programs.
10 xwininfo allows querying information about windows.
11 xinit starts the graphical server.
12 font-inconsolata-otf is the monospace font of LARBS.
13 font-libertine-otf provides the sans and serif fonts for LARBS.
14 lf is an extensive terminal file manager that everyone likes.
15 arandr is a UI for screen adjustment.
16 bc is used for a dropdown calculator.
17 calcurse is a lightweight terminal-based calendar.
18 xcompmgr is for transparency and removing screen-tearing.
19 xorg-xprop is a tool for detecting window properties.
20 libnotify allows desktop notifications.
21 dunst is a suckless notification system.
22 exfat-utils allows management of FAT drives.
23 sxiv is a minimalist image viewer.
24 xwallpaper sets the wallpaper.
25 ffmpeg can record and splice video and audio on the command line.
26 neovim an tidier vim with some useful features
27 i3blocks is the status bar.
28 i3lock is the screen lock.
29 mpd is a lightweight music daemon.
30 mpc is a terminal interface for mpd.
31 mpv is the patrician's choice video player.
32 ncmpcpp a ncurses interface for music with multiple formats and a powerful tag editor.
33 newsboat is a terminal RSS client.
34 noto-fonts-emoji is a package that gives the system unicode symbols and emojis used in the status bar and elsewhere.
35 font-symbola provides unicode and emoji symbols.
36 alsa-utils is a package of audio utilities.
37 imagemagick is a terminal image-manipulator providing some convenient shortcuts and the lockscreen in LARBS.
38 sc-im is an Excel-like terminal spreadsheet manager.
39 htop provides system usage information and displays processes.
40 maim can take quick screenshots at your request.
41 socat is a socket utility.
42 tmux is a terminal multiplexer and the dropdown window in LARBS.
43 unclutter-xfixes hides an inactive mouse.
44 unrar extracts rar's.
45 unzip unzips zips.
46 w3m is a terminal browser which can also view images.
47 xcape gives the special escape/super mappings of LARBS.
48 xclip allows for copying and pasting from the command line.
49 xdotool provides window action utilities on the command line.
50 xdpyinfo aids with resolution determination and screen recording.
51 youtube-dl can download any YouTube video (or playlist or channel) when given the link.
52 zathura is a pdf viewer with vim-like bindings.
53 zathura-djvu gives zathura the ability to read .djvu files.
54 zathura-pdf-mupdf allows mupdf pdf compatibility in zathura.
55 poppler manipulates .pdfs and gives .pdf previews and other .pdf functions.
56 mediainfo shows audio and video information and is used by vifm as well.
57 atool manages and gives information about archives.
58 fzf is a fuzzy finder tool.
59 highlight can highlight code output.
60 xorg-xbacklight enables changing screen brightness levels.
61 simple-mtpfs enables the mounting of cell phones.
62 G https://github.com/lukesmithxyz/dmenu.git runs commands and provides a UI for selection.
63 G https://github.com/lukesmithxyz/st.git is my custom build of suckless's terminal emulator.
64 G https://github.com/lukesmithxtz/surf.git is the suckless web browser.
65 docx2txt enables .docx file previews in vifm.
66 odt2txt enables .odt file previews in vifm.
67 ts queues commands or files for download.